unit Unit1;
interface
uses
  Windows, Messages, SysUtils, Classes, HTTPApp, Db, DBTables,
  DSProd;

type
  TWebModule1 = class(TWebModule)
    Table1: TTable;
    DataSetPageProducer1: TDataSetPageProducer;
    Table1SpeciesNo: TFloatField;
    Table1Category: TStringField;
    Table1Common_Name: TStringField;
    Table1SpeciesName: TStringField;
    Table1Lengthcm: TFloatField;
    Table1Length_In: TFloatField;
    Table1Notes: TMemoField;
    Table1Graphic: TGraphicField;
    procedure WebModule1WebActionItem1Action(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
    procedure DataSetPageProducer1HTMLTag(Sender: TObject; Tag: TTag;
      const TagString: String; TagParams: TStrings;
      var ReplaceText: String);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  WebModule1: TWebModule1;

implementation
{$R *.DFM}

procedure TWebModule1.WebModule1WebActionItem1Action(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
begin
  if IsMultiThread then
    Response.Content := 'This is a multi-threaded ISAPI DLL'
  else
    Response.Content := 'Warning: this ISAPI DLL is not thread-safe...';
  Response.Content :=
    Response.Content + '<HR>' + DataSetPageProducer1.Content
end;

procedure TWebModule1.DataSetPageProducer1HTMLTag(Sender: TObject;
  Tag: TTag; const TagString: String; TagParams: TStrings;
  var ReplaceText: String);
var
  Field: TField;
begin
  if TagString = 'Length' then
  begin
    if Assigned(DataSetPageProducer1.DataSet) then
    begin
      Field := DataSetPageProducer1.DataSet.FindField('Length (cm)');
      if Assigned(Field) then
        ReplaceText := Field.DisplayText
    end
  end
  else { TIME }
  begin
    if TagString = 'TIME' then
      ReplaceText := DateTimeToStr(Now)
  end
end;

end.
