unit Array6U;

interface

uses
  WinProcs, WinTypes, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, StdCtrls, Array6U2, ExtCtrls, Spin;

type
  TArray6MainForm = class(TForm)
    lstArrayContents: TListBox;
    Panel1: TPanel;
    edtElement: TEdit;
    btnGetValue: TButton;
    btnSetValue: TButton;
    edtValue: TSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnGetValueClick(Sender: TObject);
    procedure btnSetValueClick(Sender: TObject);
  private
    MyArray: TIntegerArray;
  end;

var
  Array6MainForm: TArray6MainForm;

implementation

{$R *.DFM}

procedure TArray6MainForm.FormCreate(Sender: TObject);
begin
  MyArray := TIntegerArray.Create;
end;

procedure TArray6MainForm.FormDestroy(Sender: TObject);
begin
  MyArray.Free
end;

procedure TArray6MainForm.btnGetValueClick(Sender: TObject);
begin
  edtValue.Value := MyArray[edtElement.Text]
end;

procedure TArray6MainForm.btnSetValueClick(Sender: TObject);
begin
  MyArray[edtElement.Text] := edtValue.Value;
  lstArrayContents.Items := MyArray.List
end;

end.
